#include "DS1631.h"

#if USE_DS1631

	#include <avr\io.h>
	#include "i2cmaster.h"


	#define DS1631 0x90
	#define I2C_ADRESSE 0xE
	#define THERMOMETER (DS1631 + I2C_ADRESSE)

	#define DEBUG_I2C(x) uart_puts_P(x)
	//#define DEBUG_I2C(...)

	void DS1631_init (void)
	{
		i2c_init();

		i2c_start_wait(THERMOMETER + I2C_WRITE);
		i2c_write(ACCESS_CONFIG);
		i2c_write(0x68); //11 bit Auflsung | Tout = active low | continuose mode
		i2c_stop();

		i2c_start_wait(THERMOMETER + I2C_WRITE);
		i2c_write(ACCESS_TH);
		i2c_write(24);
		i2c_write(5);
		i2c_stop();

		i2c_start_wait(THERMOMETER + I2C_WRITE);
		i2c_write(ACCESS_TL);
		i2c_write(22);
		i2c_write(0);
		i2c_stop();

		i2c_start_wait(THERMOMETER + I2C_WRITE);
		i2c_write(START_CONVERT);
		i2c_stop();
	}
	
	void DS1631_get_temp (void)
	{
		static char firstrun = 0;
		i2c_start_wait(THERMOMETER + I2C_WRITE);
		i2c_write(READ_TEMPERATURE);
		i2c_rep_start(THERMOMETER + I2C_READ);
		var_array[0] = i2c_readAck();
		var_array[1] = i2c_readNak()/2.56;
		i2c_stop();
		if (firstrun == 0)
		{
			var_array[2] = var_array[0];
			var_array[3] = var_array[1];
			var_array[4] = var_array[0];
			var_array[5] = var_array[1];
			firstrun = 1;
		} 
		else 
		{
			if ((var_array[0] > var_array[2]) || ((var_array[0] == var_array[2]) && (var_array[1] > var_array[3])))
			{
				var_array[2] = var_array[0];
				var_array[3] = var_array[1];
			}
			if ((var_array[0] < var_array[4]) || ((var_array[0] == var_array[4]) && (var_array[1] < var_array[5])))
			{
				var_array[4] = var_array[0];
				var_array[5] = var_array[1];
			}
			
			/*if ((var_array[0] > var_array[2]) && (var_array[1] > var_array[3]))
			{
				var_array[2] = var_array[0];
				var_array[3] = var_array[1];
			}
			if ((var_array[0] < var_array[4]) && (var_array[1] < var_array[5]))
			{
				var_array[4] = var_array[0];
				var_array[5] = var_array[1];
			}*/
		}
	}

#endif
