/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        03.11.2007
 Description:    Webserver Config-File
----------------------------------------------------------------------------*/

#ifndef _CONFIG_H_
	#define _CONFIG_H_	
	#include "8bit_defs.h"
	
	//ETH_M32_EX (www.ulrichradig.de)
	#define USE_ENC28J60	1
	//Holger Buss (www.mikrocontroller.com) Mega32-Board
	#define USE_RTL8019		0
	
	//Konfiguration der PORTS (MSB......LSB)
	//1=OUTPUT / 0=INPUT
	#define OUTA 		b00000111
	#define OUTC 		b00000000
	#define OUTD 		b00000000
	//Achtung!!!! an PORTB ist der ENC
	//nur ndern wenn man wei was man macht!


	//Umrechnung von IP zu unsigned long
	#define IP(a,b,c,d) ((unsigned long)(d)<<24)+((unsigned long)(c)<<16)+((unsigned long)(b)<<8)+a

	//IP des Webservers
	#define MYIP		IP(192,168,178,18)

	//Netzwerkmaske
	#define NETMASK		IP(255,255,255,0)
	
	//IP des Routers
	#define ROUTER_IP	IP(192,168,178,1)
	
	//IP des NTP-Servers z.B. Server 1.de.pool.ntp.org
	#define USE_NTP		1 //1 = NTP Client on
	#define NTP_IP		IP(77,37,6,59)
	
	//Broadcast-Adresse fr WOL
	#define USE_WOL			1 //1 = WOL on
	#define WOL_BCAST_IP	IP(192,168,178,255)
	#define WOL_MAC 		{0x00,0x16,0xD4,0x3F,0x58,0xF5}  //Laptop Simon
	//#define WOL_MAC 		{0x00,0x16,0xD4,0x64,0xF6,0x05}	 //Laptop Regina
	//#define WOL_MAC 		{0x00,0x11,0x32,0x01,0x3E,0x4a}  //Diskstation
	
	//MAC Adresse des Webservers	
	#define MYMAC1	0x00
	#define MYMAC2	0x20
	#define MYMAC3	0x18
	#define MYMAC4	0xB1	
	#define MYMAC5	0x15
	#define MYMAC6	0x6F
	
	//Taktfrequenz
	#define F_CPU 16000000UL	
	//#define F_CPU 14745600UL
	//#define F_CPU 11059200UL
	
	//Timertakt intern oder extern
	#define EXTCLOCK 0 //0=Intern 1=Externer Uhrenquarz

	//Baudrate der seriellen Schnittstelle
	#define BAUDRATE 9600
	
	//LCD Routinen mit einbinden
	#define USE_SER_LCD		0

	//AD-Wandler benutzen?
	#define USE_ADC			0
	
	//Verwenden des DS1631 zum messen der Umgebungstemperatur
	#define USE_DS1631 1

	//Kamera mit einbinden
	//Kamera arbeitet nur mit einem 14,7456Mhz Quarz!
	#define USE_CAM			0
	#define USE_SERVO		0
	//In cam.c knnen weitere Parameter eingestellt werdehep
	//z.B. Licht, Kompression usw.
	//Auflsungen
	//0 = 160x120 Pixel krzer (zum testen OK ;-)
	//1 = 320x240 Pixel ca. 10 Sek. bei einem Mega644
	//2 = 640x480 Pixel lnger (dauert zu lang!)
	#define CAM_RESELUTION	0
	

	
	//Webserver mit Passwort? (0 == mit Passwort)
	#define HTTP_AUTH_DEFAULT	0
	
	//AUTH String "USERNAME:PASSWORT" max 14Zeichen 
	//fr Username:Passwort
	#define HTTP_AUTH_STRING "admin:Regina"
	
#endif //_CONFIG_H


